package com.jqtx.windows.common.mq;

import cn.hutool.core.util.IdUtil;
import cn.hutool.core.util.ObjectUtil;
import com.alibaba.fastjson.JSON;
import com.jqtx.infrastructure.mq.starter.annotation.MQConsumerComponent;
import com.jqtx.windows.command.GetCreditCommand;
import com.jqtx.windows.common.mq.model.CreditResultModel;
import com.jqtx.windows.component.CreditComponent;
import com.jqtx.windows.component.enums.CreditResultStatusEnum;
import com.jqtx.windows.component.enums.ZNPostUrlEnum;
import com.jqtx.windows.component.model.CreditModel;
import com.jqtx.windows.utils.AbcHttpClient;
import com.jqtx.windows.web.response.CreditDetailResponse;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;

/**
 * @author BlackJokerCJ
 * @Date 2021/2/27
 */
@Slf4j
@MQConsumerComponent(tags = "criusCreditResult", topic = "$mq.creditTopic")
public class CreditResultListener extends AbstractMQConsumerHandler<CreditResultModel> {

    @Autowired
    private CreditComponent creditComponent;

    @Autowired
    private AbcHttpClient abcHttpClient;

    @Autowired
    private GetCreditCommand getCreditCommand;
    @Override
    public Class getClazz() {
        return CreditResultModel.class;
    }

    @Override
    public void run(CreditResultModel creditResultModel) throws Exception {
        CreditModel byOrderNo = creditComponent.getByOrderNo(creditResultModel.getOrderNo());
        if(ObjectUtil.isNull(byOrderNo) || !CreditResultStatusEnum.INIT.name().equals(byOrderNo.getCreditResult())){
            return;
        }
        CreditModel update =  new CreditModel();
        if ("YES".equalsIgnoreCase(creditResultModel.getCreditStatus())) {
            update.setCreditResult(CreditResultStatusEnum.PASS.getCode());
        }
        if ("RETRIAL".equalsIgnoreCase(creditResultModel.getCreditStatus())) {
            update.setCreditResult(CreditResultStatusEnum.INIT.getCode());
        }
        if ("REJECT".equalsIgnoreCase(creditResultModel.getCreditStatus())) {
            update.setCreditResult(CreditResultStatusEnum.REFUSED.getCode());
        }
        creditComponent.updateByOrderNo(byOrderNo.getOrderNo(),update);
        CreditDetailResponse convert = getCreditCommand.convert(byOrderNo.getOrderNo());
        convert.setTransNo(IdUtil.fastSimpleUUID());
        abcHttpClient.postRequest(JSON.toJSONString(convert), ZNPostUrlEnum.CREDIT_CALL.getCode());
    }
}

