package com.jqtx.windows.utils;

import cn.hutool.http.HttpRequest;
import cn.hutool.http.HttpResponse;
import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.jqtx.windows.web.request.AbcRequest;
import com.jqtx.windows.web.response.JsonResult;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.lang.StringUtils;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Component;

@Slf4j
@Component
public class AbcHttpClient {


    @Value("${zhenong.url}")
    private String posetUrl;
    @Value("${zhenong.yyPrivateKey}")
    private String privateKey;

    @Value("${zhenong.publicKey}")
    private String ypdPublicKey;
    private String appId = "660010";

    public JsonResult postRequest(String paramJson, String method) {
        try {
            final String url = posetUrl+method;
            AbcRequest request = AbcRsaUtil.encodeParam(paramJson, ypdPublicKey, appId, privateKey);
            log.info("请求浙农request:{}, url:{}", JSON.toJSONString(request), url);
            HttpResponse response = HttpRequest.post(url).body(JSON.toJSONString(request)).setConnectionTimeout(5000).execute();
            if (response.getStatus() == 200 && StringUtils.isNotBlank(response.body())) {
                final String body = response.body();
                log.info("请求浙农response:{}", body);
                JSONObject responseJson = JSONObject.parseObject(body);
                String content = responseJson.getString("content");
                String sign = responseJson.getString("sign");
                String responseParam = AbcRsaUtil.decodeParam(content, sign, privateKey, ypdPublicKey);
                return JSONObject.parseObject(responseParam, JsonResult.class);
            } else {
                throw new Exception("请求异常");
            }
        } catch (Exception e) {
            log.error("请求浙农异常:{}",e.getMessage(),e);
            return null;
        }
    }
}
